% Definiere rechte Seite der Diff.-Gl.
A = [-1/2, -869/10,  1521/5;  ...
        0,  -227/2,   591/2;  ...
        0,   591/2, -1803/2];
f = @(t,y) A*y;

% Setze Anfangs/EndZeit und Anfangswerte
t0 = 0.;
T  = 2.;
y0 = [1.;6.;2.;];

% berechne die exakte Loesung zur Endzeit
ye = expm(A*T)*y0; % Hier verwenden wir die Matrix-Exponential Fkt weil
                   % es kuerzer ist zu schreiben!

% Berechne GDF fuer verschiedene Schrittweiten h
for i=0:15
  % Loese numerisch mit dem verbesserten Euler Verfahren
  h(i+1) = 0.5^i;
  N = (T - t0)/h(i+1);
  [t,yn] = verbEuler(f,t0,T,y0,N);
  % Berechne GDF zur Endzeit
  err(i+1) = norm(yn(:,end) - ye);
end

% plotte GDF
clf;
loglog(h,err,'b-o');
ylim([1.e-11,1.e11]);
xlabel('h');
ylabel('Fehler');

p = polyfit(log(h(11:15)), log(err(11:15)), 1);
fprintf('Empirische Konvergenzrate: %1.2f\n', p(1));